/* Copyright (C)  2006-2009, Vlad Volodin <vest.84@gmail.com>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtkmm.h>
#include <librsvg/rsvg.h>
#include <stdlib.h>
#include <glibmm/i18n.h>

#include "mainwindow.h"
#include "background.h"

int main (int argc, char *argv[])
{
    bindtextdomain (GETTEXT_PACKAGE, PROGRAMNAME_LOCALEDIR);
    bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
    textdomain (GETTEXT_PACKAGE);

    Background::Clear ();
    try
    {
        Background::ScanGameDir ();
    }
    catch (const file_exception& e)
    {
        std::cerr << e.what () << std::endl;
    }

    try
    {
        Background::ScanHomeDir ();
    }
    catch (const file_exception& e)
    {
        std::cerr << e.what () << std::endl;
    }

    Gtk::Main kit (argc, argv);
    rsvg_init ();

#ifdef NDEBUG
    srand (time (0));
#endif //NDEBUG

    MainWindow window;

    Gtk::Main::run (window);
    rsvg_term ();

    return 0;
}
