/* Copyright (C)  2006-2009, Vlad Volodin <vest.84@gmail.com>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _TOPTIONS_H
#define	_TOPTIONS_H

#include "types.h"
#include "player.h"

class TOptions
{
public:

    enum TAlign
    {
        Left, Right
    };

    static const Glib::ustring FILENAME_OPTIONS;
    static const Glib::ustring FILENAME_DTD;

    TOptions ();
    TOptions (const TOptions& orig);
    virtual ~TOptions ();

    TOptions& operator = (const TOptions& o);

    static TOptions LoadOptions ();
    static void SaveOptions (const TOptions& options);

public:
    TPlayer firstPlayer;
    TPlayerOption bluePlayer;
    TPlayerOption redPlayer;
    int pause; // in milliseconds

    Glib::ustring bgPath;   // background path
    TAlign helpAlign;       // align help menu

    double lineWidth;       // square line width
};

#endif	/* _TOPTIONS_H */
