/* Copyright (C)  2006-2009, Vlad Volodin <vest.84@gmail.com>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _OPTIONSWINDOW_H
#define	_OPTIONSWINDOW_H

#include <gtkmm.h>
#include "types.h"
#include "options.h"

class OptionsWindow : public Gtk::Dialog
{
public:
    typedef std::list<Glib::ustring> type_listStrings;

    OptionsWindow (Gtk::Window& parent, const TOptions& options);
    virtual ~OptionsWindow ();

    virtual void GetOptions (TOptions& options) const;
    
protected:
    virtual void add_row (Gtk::Table& table, int row,
                          const Glib::RefPtr<Gtk::SizeGroup>& size_group,
                          const Glib::ustring& label_text,
                          Gtk::Widget& widget);
    virtual Gtk::ComboBoxText* create_combobox (const std::list<Glib::ustring>& strings);
    virtual void SetOptions (const TOptions& options);
    virtual void on_combo_changed ();

private:
    Gtk::Table m_optionsTable;
    Glib::RefPtr<Gtk::SizeGroup> m_refSizeGroup;

    Gtk::ComboBoxText* pm_firstCombo;
    Gtk::ComboBoxText* pm_blueCombo;
    Gtk::ComboBoxText* pm_redCombo;

    const TOptions& options;
};

#endif	/* _OPTIONSWINDOW_H */
