/* Copyright (C)  2006-2009, Vlad Volodin <vest.84@gmail.com>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _PLAYERPANEL_H
#define	_PLAYERPANEL_H

#include <gtkmm.h>
#include <librsvg/rsvg.h>
#include <librsvg/rsvg-cairo.h>

#include "player.h"

class PlayerPanel : public Gtk::DrawingArea
{
public:
    PlayerPanel (const Player* player);
    virtual ~PlayerPanel ();
    virtual void Assign (const Player* player);

protected:
    //Override default signal handler:
    virtual bool on_expose_event (GdkEventExpose* event);

private:
    static const int MIN_WIDTH = 110;
    static const int MIN_HEIGHT = 130;

    const Player* player;

    RsvgHandle* rsvgColor;
    RsvgHandle* rsvgWhite;

    RsvgDimensionData dColor;
    RsvgDimensionData dWhite;
};

#endif	/* _PLAYERPANEL_H */

