/* Copyright (C)  2006-2009, Vlad Volodin <vest.84@gmail.com>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _TSTATISTIC_H
#define	_TSTATISTIC_H

#include "options.h"


class TPlayerStat
{
public:
    TPlayerStat ();
    TPlayerStat (const TPlayerStat& o);
    TPlayerStat & operator = (const TPlayerStat& o);
    virtual ~TPlayerStat ();

    static const Glib::ustring GAME_TYPE[];

public:
    int human_human;
    int human_easy;
    int human_hard;
    int easy_easy;
    int easy_hard;
    int hard_hard;
};

class TStatistics
{
public:
    static const Glib::ustring FILENAME_STATISTICS;
    static const Glib::ustring FILENAME_DTD;

    TStatistics ();
    TStatistics (const TStatistics& o);
    TStatistics & operator = (const TStatistics& o);
    virtual ~TStatistics ();

    void IncreaseStatistics(TWinnerState state, TOptions curOptions);

    static TStatistics LoadStatistics ();
    static void SaveStatistics (const TStatistics& statistics);

public:
    TPlayerStat blue_blue; // the first player — blue, won — blue
    TPlayerStat blue_red; // the first player — blue, won — red
    TPlayerStat blue_draw; // the first player — blue, draw

    TPlayerStat red_blue; // the first player — red, won — blue
    TPlayerStat red_red; // the first player — red, won — red
    TPlayerStat red_draw; // the first player — red, won — draw
};

#endif	/* _TSTATISTIC_H */
