/* Copyright (C)  2006-2009, Vlad Volodin <vest.84@gmail.com>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _STATWINDOW_H
#define	_STATWINDOW_H

#include <gtkmm.h>

#include "statistics.h"

class StatWindow : public Gtk::Dialog
{
public:
    static const Glib::ustring TABLE[][2];
    static const int DEFAULT_ICON_SIZE;

    StatWindow (Gtk::Window& parent, const TStatistics& stat);
    virtual ~StatWindow ();

private:
    Gtk::Table m_statTable;

    Gtk::VSeparator m_vertSeparator1;
    Gtk::VSeparator m_vertSeparator2;

    Gtk::HSeparator m_horSeparator1;
    Gtk::HSeparator m_horSeparator2;

    Gtk::Label m_blueFirstLabel;
    Gtk::Label m_redFirstLabel;

    Gtk::Label m_blue1Label;
    Gtk::Label m_red1Label;

    Gtk::Label m_blue2Label;
    Gtk::Label m_red2Label;

    Gtk::Widget* get_image(Glib::RefPtr<Gtk::IconTheme> iconTheme,
                                 Glib::ustring name);
};

#endif	/* _STATWINDOW_H */

